/*
#include<iostream>
#include<set>
using namespace std;
int a[300000], r_up[300000], l_down[300000];
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	set<pair<int, int>> result;
	long long int res = 0;
	int n; cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int i = 0; i < n - 1; ++i) {
		int j = i + 1;
		while (j < n && a[j] > a[j - 1]) {
			r_up[j]++;
			//result.insert({ i,j });
			res++;
			j++;

		}
	}
	for (int i = 0; i < n - 1; ++i) {
		int j = i + 1;
		while (j < n && a[j] < a[j - 1]) {
			l_down[i]++;
			//result.insert({ i,j });
			res++;
			j++;
		}
	}
	for (int i = 1; i < n - 1; ++i) {
		if (r_up[i] != 0 && l_down[i] != 0) {
			res += r_up[i] * l_down[i];
		}
	}
	cout << res + n;
	return 0;
}*/
#include<iostream>
#include<vector>
#include<map>
#define ll unsigned long long int

using namespace std;
ll a[20][20];
ll dp[20][20], prefix_sums[20][20];

int n, m;
ll s;

ll dsum(int x1, int x2, int y1, int y2) {
	if (x1 == 0 && y1 == 0)
		return dp[x2][y2];
	if (y1 == 0)
		return dp[x2][y2] - dp[x1 - 1][y2];
	if (x1 == 0)
		return dp[x2][y2] - dp[x2][y1 - 1];
	return dp[x2][y2] - dp[x1 - 1][y2] - dp[x2][y1 - 1] + dp[x1 - 1][y1 - 1];
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			cin >> a[i][j];
	cin >> s;
	
	for (int i = 0; i < n; ++i) {
		prefix_sums[i][0] = a[i][0];
		for (int j = 1; j < m; ++j)
			prefix_sums[i][j] = prefix_sums[i][j - 1] + a[i][j];
	}

	for (int j = 0; j < m; ++j)
		dp[0][j] = prefix_sums[0][j];

	for (int i = 1; i < n; ++i)
		dp[i][0] = prefix_sums[i][0] + dp[i - 1][0];

	for (int i = 1; i < n; ++i)
		for (int j = 1; j < m; ++j)
			dp[i][j] = prefix_sums[i][j] + dp[i - 1][j];

	for (int x1 = 0; x1 < n; ++x1) {
		for (int y1 = 0; y1 < m; ++y1) {
			for (int x2 = 0; x2 < n; ++x2) {
				for (int y2 = 0; y2 < m; ++y2) {
					if (dsum(x1, x2, y1, y2) == s) {
						cout << "YES" << endl;
						//cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
						x1++; y1++; x2++; y2++;
						cout << (x1 - 1) + (y1 - 1) + (n - x2) + (m - y2) << endl;
						while (x1 > 1) {
							cout << 1 << " " << x1 - 1 << endl;
							x1--;
						}
						while (x2 < n) {
							cout << 1 << " " << x2 + 1 << endl;
							x2++;
						}
						while (y1 > 1) {
							cout << 2 << " " << y1 - 1 << endl;
							y1--;
						}
						while (y2 < m) {
							cout << 2 << " " << y2 + 1 << endl;
							y2++;
						}
						return 0;
					}
				}
			}
		}
	}

	for (int x1 = 0; x1 < n; ++x1) {
		for (int y1 = 0; y1 < m; ++y1) {
			for (int x2 = 0; x2 < n; ++x2) {
				for (int y2 = 0; y2 < m; ++y2) {
					for (int y3 = y2 + 2; y3 < m; ++y3) {
						for (int y4 = y3; y4 < m; ++y4) {
							if (dsum(x1, x2, y1, y2) + dsum(x1, x2, y3, y4) == s) {
								cout << "YES" << endl;
								x1++, x2++, y1++, y2++, y3++, y4++;
								cout << (x1 - 1) + (n - x2) + (y1 - 1) + (m - y4) + (y3 - y2 - 1) << endl;
								while (x1 > 1) {
									cout << 1 << " " << x1 - 1 << endl;
									x1--;
								}
								while (x2 < n) {
									cout << 1 << " " << x2 + 1 << endl;
									x2++;
								}
								while (y1 > 1) {
									cout << 2 << " " << y1 - 1 << endl;
									y1--;
								}
								while (y4 < m) {
									cout << 2 << " " << y4 + 1 << endl;
									y4++;
								}
								while (y2  + 1 < y3) {
									cout << 2 << " " << y2 + 1 << endl;
									y2++;
								}
								return 0;
							}
						}
					}
				}
			}
		}
	}

	cout << "NO";
	return 0;
}